VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00E0E0E0&
   Caption         =   "PC Quad MCP3204 12bit ADC DVM v2.0"
   ClientHeight    =   1440
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   3990
   FillColor       =   &H00C0C0C0&
   ForeColor       =   &H8000000E&
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   1440
   ScaleWidth      =   3990
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdEXit 
      Caption         =   "Exit"
      Height          =   315
      Left            =   3150
      TabIndex        =   5
      Top             =   1020
      Width           =   615
   End
   Begin VB.CheckBox chkLog 
      BackColor       =   &H00E0E0E0&
      Caption         =   "Log Enable"
      ForeColor       =   &H00C00000&
      Height          =   225
      Left            =   120
      TabIndex        =   2
      Top             =   1080
      Width           =   1215
   End
   Begin MSComDlg.CommonDialog cdlFiles 
      Left            =   2250
      Top             =   810
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Timer Timer1 
      Interval        =   200
      Left            =   1650
      Top             =   840
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackColor       =   &H00E0E0E0&
      Caption         =   "Chan3"
      Height          =   255
      Index           =   3
      Left            =   3150
      TabIndex        =   9
      Top             =   150
      Width           =   615
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackColor       =   &H00E0E0E0&
      Caption         =   "Chan2"
      Height          =   255
      Index           =   2
      Left            =   2160
      TabIndex        =   8
      Top             =   150
      Width           =   615
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackColor       =   &H00E0E0E0&
      Caption         =   "Chan1"
      Height          =   255
      Index           =   1
      Left            =   1200
      TabIndex        =   7
      Top             =   150
      Width           =   615
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackColor       =   &H00E0E0E0&
      Caption         =   "Chan0"
      Height          =   255
      Index           =   0
      Left            =   270
      TabIndex        =   6
      Top             =   150
      Width           =   615
   End
   Begin VB.Label lblAvg3 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "V4"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000080FF&
      Height          =   285
      Left            =   3030
      TabIndex        =   4
      Top             =   450
      Width           =   825
   End
   Begin VB.Label lblAvg2 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "V3"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00008000&
      Height          =   285
      Left            =   2070
      TabIndex        =   3
      Top             =   450
      Width           =   825
   End
   Begin VB.Label lblAvg0 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "V0"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   285
      Left            =   150
      TabIndex        =   0
      Top             =   450
      Width           =   825
   End
   Begin VB.Label lblAvg1 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "V1"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   285
      Left            =   1110
      TabIndex        =   1
      Top             =   450
      Width           =   825
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Nov2008 MCP3204 ParaDVM2 V1.0
'Uses parallel port connected to a MCP3204 Quad 12 Bit ADC
'You MUST have
Option Explicit

Dim V0mult, V1mult, V2mult, V3mult As Single

Dim ADCValue0, ADCValue1, ADCValue2, ADCValue3 As Single

Dim Ary(24) As Long

Dim Volt0, Volt1, Volt2, Volt3 As Single
Dim AvgV0, AvgV1, AvgV2, AvgV3 As Single

Dim fName As String
Dim hfile

Dim CmdStr0, CmdStr1, CmdStr2, CmdStr3 As String

'parallel port addresses
Const Po378 = &H378, Pi379 = &H379, P37A = &H37A, P37B = &H37B

'constants for SPI addressing, E-nable,D-ata,C-hip select
'h = bit high, l = bit low
Const EhDhCh = 7 'cs hi, do hi, clk hi'' ready state
Const ElDhCh = 3 'cs lo, do hi, clk hi
Const ElDhCl = 2 'cs lo, do hi, clk lo
Const ElDlCh = 1 'cs lo, do lo, clk hi
Const ElDlCl = 0 'cs lo, do lo, clk lo

'masking bit
Const Dinp = &H80 '' '0000,0001_1000,0000_0000,0000


Private Sub Form_Load()

Form1.Show

MakePwrAry

'command string sent to MCP3204
CmdStr0 = Trim("000001100000000000000000") ' chn0
CmdStr1 = Trim("000001100100000000000000") ' chn1
CmdStr2 = Trim("000001101000000000000000") ' chn2
CmdStr3 = Trim("000001101100000000000000") ' chn3

'adc value multiplier
V0mult = 1
V1mult = 1
V2mult = 1
V3mult = 1

End Sub


Private Sub ReadADC0to3()
'read all 4 adc channels and display

Dim p, V As Integer

AvgV0 = 0: AvgV1 = 0: AvgV2 = 0: AvgV3 = 0
Volt0 = 0: Volt1 = 0: Volt2 = 0: Volt3 = 0

ADCValue0 = 0: ADCValue1 = 0: ADCValue2 = 0: ADCValue3 = 0

DoEvents

'channel0
Out Po378, ElDhCh
'send  data bits to ADC0 msb 1st
For p = 1 To 24
    If Mid$(CmdStr0, p, 1) = "1" Then
    Out Po378, ElDhCh
    Out Po378, ElDhCl
    Out Po378, ElDhCh
    Else ' lo
    Out Po378, ElDlCh
    Out Po378, ElDlCl
    Out Po378, ElDlCh
    End If

'read each bit and evaluate the weighting, load the array with sum
'if bit is '1' then get Ary value else skip
    V = Inp(Pi379) And Dinp
        If V <> Dinp Then
        ADCValue0 = ADCValue0 + Ary(p)
        End If
Next p
Out Po378, EhDhCh 'idle

'divide by 12 bit [4096] and change to a voltage
'change the '5' to suit your parameter scaling
    Volt0 = (ADCValue0 / 4096) * 5
    AvgV0 = AvgV0 + Volt0

DoEvents

'chan 1--------------------------------------
'send  data bits to ADC1 msb 1st
Out Po378, EhDhCh
For p = 1 To 24
    If Mid$(CmdStr1, p, 1) = "1" Then
    Out Po378, ElDhCh
    Out Po378, ElDhCl
    Out Po378, ElDhCh
    Else ' lo
    Out Po378, ElDlCh
    Out Po378, ElDlCl
    Out Po378, ElDlCh
    End If

    V = Inp(Pi379) And Dinp
        If V <> Dinp Then
        ADCValue1 = ADCValue1 + Ary(p)
        End If
Next p
Out Po378, EhDhCh
    Volt1 = (ADCValue1 / 4096) * 5
    AvgV1 = AvgV1 + Volt1

DoEvents

'chan 2 ---------------------------
'send  data bits to ADC2 msb 1st
Out Po378, EhDhCh
For p = 1 To 24
    If Mid$(CmdStr2, p, 1) = "1" Then
    Out Po378, ElDhCh
    Out Po378, ElDhCl
    Out Po378, ElDhCh
    Else ' lo
    Out Po378, ElDlCh
    Out Po378, ElDlCl
    Out Po378, ElDlCh
    End If

    V = Inp(Pi379) And Dinp
        If V <> Dinp Then
        ADCValue2 = ADCValue2 + Ary(p)
        End If
Next p
Out Po378, EhDhCh
    Volt2 = (ADCValue2 / 4096) * 5
    AvgV2 = AvgV2 + Volt2

'chan 3 ----------------------------------------
DoEvents
'send  data bits to ADC3 msb 1st
Out Po378, ElDhCh
For p = 1 To 24
    If Mid$(CmdStr3, p, 1) = "1" Then
    Out Po378, ElDhCh
    Out Po378, ElDhCl
    Out Po378, ElDhCh
    Else ' lo
    Out Po378, ElDlCh
    Out Po378, ElDlCl
    Out Po378, ElDlCh
    End If
    
    V = Inp(Pi379) And Dinp
        If V <> Dinp Then
        ADCValue3 = ADCValue3 + Ary(p)
        End If
Next p

Out Po378, EhDhCh
    Volt3 = (ADCValue3 / 4096) * 5
    AvgV3 = AvgV3 + Volt3

'=======================================
'now display all channel results
lblAvg0.Caption = Format(AvgV0 * V0mult, "#0.000")
lblAvg1.Caption = Format(AvgV1 * V1mult, "#0.000")
lblAvg2.Caption = Format(AvgV2 * V2mult, "#0.000")
lblAvg3.Caption = Format(AvgV3 * V3mult, "#0.000")

'log to a text data file
If chkLog.Value = Checked Then
Print #hfile, "T" & Time & ",A" & lblAvg0.Caption & ",B" & lblAvg1.Caption & _
",C" & lblAvg2.Caption & ",D" & lblAvg3.Caption
End If

End Sub

Private Sub Timer1_Timer()
'set the timer1 interval to suit your sampling period.
'100mS thru 32000 mS
ReadADC0to3
End Sub


Private Sub MakePwrAry()

'this power array is used for bit weighting in the adc bit pattern

Dim p, z As Integer

p = 1
    For z = 24 To 13 Step -1
    Ary(z) = p
    p = p * 2
    Next z

    For z = 12 To 1 Step -1
    Ary(z) = 0
    Next z

End Sub

Private Sub chkLog_Click()

'save all channels data as text to a filed named as current time.
'change the fname to suit your filing system.
'
    If chkLog.Value = Checked Then
    Close hfile
    hfile = FreeFile
    fName = "C:\MCP3204\adc" & Format(Time, "hhmmss")
    Open fName & ".txt" For Output As hfile
    Print #hfile, Now
    Else
    Close hfile
    End If

End Sub

Private Sub cmdEXit_Click()
End
End Sub



